package vin;

import java.awt.BorderLayout;
import java.io.*;

import javax.swing.JFrame;

import java.awt.*;
import java.awt.Point;


import java.awt.Graphics;
import java.awt.Toolkit;
import java.awt.Image;
import java.awt.image.*;
import java.awt.image.BufferedImage;
import javax.imageio.ImageIO;
import javax.imageio.ImageWriteParam;
import javax.imageio.ImageWriter;
import javax.imageio.IIOImage;
import javax.imageio.stream.ImageOutputStream;

import java.util.ArrayList;
import java.util.Iterator;

import java.awt.event.MouseEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseMotionAdapter;

import java.awt.geom.AffineTransform;

import java.util.Map;
import java.util.HashMap;


public class DrawFrame extends JFrame implements Serializable {
    // gui
    BorderLayout borderLayout1 = new BorderLayout();
    MainFrame mainFrame;
    private Point mousePos = new Point(-1,-1);
    private boolean mouseMove = false;
    public Graphics g;
    
    // drawing
    private double[][] birdobj;
    public Graphics2D ig2d;
    public BufferedImage bufferedImage;
        
    // options
    public int numobjs = 200;
    public double grav = 0.7;
    public double max = 20.0;
    public String str = new String(".");
    public Color col = new Color(0,0,0);
    public Color bgcol = new Color(255,254,0);
    public int currentStyle = Font.BOLD;
    public String currentStyleString = "bold";
    public String currentFont = "Arial Black";
    public int quality = 1;
    public int format = 0;
    
    // konstruktor tridy    
    public DrawFrame(MainFrame mainFrame) {
        this.mainFrame = mainFrame;
        try {
            jbInit();
        } catch (Exception exception) {
            exception.printStackTrace();
        }
    }
  
    // inicializace 
    private void jbInit() throws Exception {
        setSize(new Dimension(1000, 800));
        setTitle("Vykreslovaci okno");
        this.addMouseMotionListener(new DrawFrame_this_mouseMotionAdapter(this));
        this.addMouseListener(new DrawFrame_this_mouseAdapter(this));
        this.getContentPane().setLayout(borderLayout1);
        
        
       
        bufferedImage = new BufferedImage(this.getWidth(), this.getHeight(), BufferedImage.TYPE_INT_RGB);         
        ig2d = bufferedImage.createGraphics();                
      
        initObjs(numobjs);     
    }
    
    // inicializace vykreslovanch objekt
    public void initObjs(int num) {      
      this.numobjs = num;
      this.birdobj = new double[num][6];      
      for (int i = 0; i < num; i++) {
        this.birdobj[i][0] = Math.random()*this.getWidth(); // x-ova slozka pozice
        this.birdobj[i][1] = Math.random()*this.getHeight(); // y-ova slozka pozice
        this.birdobj[i][2] = Math.random()*100.0; // uhel rotace objektu
        this.birdobj[i][3] = Math.random()*100.0-50.0; // x-ova slozka vektoru rychlosti
        this.birdobj[i][4] = Math.random()*100.0-50.0; // y-ova slozka vektoru rychlosti
        this.birdobj[i][5] = Math.random()*100.0; // velikost objektu      
      } 
    }

    private void readObject(ObjectInputStream ois) throws IOException, ClassNotFoundException {
        ois.defaultReadObject();
    }

    private void writeObject(ObjectOutputStream oos) throws IOException {
        oos.defaultWriteObject();
    }

    // prekresleni okna
    public void paint(java.awt.Graphics g) {
        this.g = g;
        super.paint(g);
        this.myPaint(g, false, this.mouseMove);
        this.mouseMove = false;        
    }
  
 

    // vykresleni okna
    public void myPaint(Graphics g, boolean toImage, boolean recalc) {

      int colorR, colorG, colorB;
      int widhtDiv2, heightDiv2;
      
      Graphics2D gg = (Graphics2D)g;
      if (toImage)
        gg = ig2d;

      // nastaveni parametru pro vykreslovani
      Map myMap = new HashMap();      
      
      if (!toImage && quality==1) { // pro vykresleni volime jako vychozi mensi kvalitu zobrazeni - rychlost je dulezitejsi
        myMap.put(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_OFF); 
        myMap.put(RenderingHints.KEY_COLOR_RENDERING, RenderingHints.VALUE_COLOR_RENDER_SPEED); 
        myMap.put(RenderingHints.KEY_INTERPOLATION, RenderingHints.VALUE_INTERPOLATION_NEAREST_NEIGHBOR); 
      } else { // do souboru ukladame s nejvyssi kvalitou zobrazeni - visualni kvalita je dulezitejsi
        myMap.put(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON); 
        myMap.put(RenderingHints.KEY_COLOR_RENDERING, RenderingHints.VALUE_COLOR_RENDER_QUALITY); 
        myMap.put(RenderingHints.KEY_INTERPOLATION, RenderingHints.VALUE_INTERPOLATION_BICUBIC); 
      }
      
      gg.addRenderingHints(myMap);
    
      // prepocet velikosti okna
      widhtDiv2 = this.getWidth()/2;
      heightDiv2 = this.getHeight()/2;      

      // nastaveni barvy pozadi
      gg.setBackground(bgcol);
      gg.setColor(bgcol);
      gg.fillRect(0,0,this.getWidth(),this.getHeight());
    
      // vypocet novych parametru objektu a jeho vykresleni
      
      for(int i=0;i<numobjs;i++) {    
      
        double[] obj = new double[6];
        obj = birdobj[i];
    
        double opp = mousePos.getY() - (int)obj[1];
  			double adj = mousePos.getX() - (int)obj[0];
  			
  			double dist = Math.sqrt(opp*opp + adj*adj);       

        if (!toImage && recalc) {
    			obj[3] += grav*(adj/dist);
    			obj[4] += grav*(opp/dist);
    			
    			if(obj[3] > this.max) {
    				obj[3]=this.max;
    				}
    			else if(obj[3] <-this.max) {
    				obj[3]=-this.max;
    				}
    			if(obj[4] > this.max) {
    				obj[4]=this.max;
    				}
    			else if(obj[4] < -this.max){
    				obj[4]=-this.max;
    				}
    			
    			obj[0] += obj[3]*.5;
    			obj[1] += obj[4]*.5;
    			
    		  obj[2] += 0.1; // rotace
        }   			

        // vypocet barvy objektu         
        /*
        int red = (int)(dist/this.getWidth()*col.getRed());
        int blue = (int)(dist/this.getWidth()*col.getBlue());
        int green = (int)(dist/this.getWidth()*col.getGreen());
        */
        int red = (int)(col.getRed());
        int blue = (int)(col.getBlue());
        int green = (int)(col.getGreen());
        
               
        red = (red > 255)?255:red; 
        blue = (blue > 255)?255:blue;
        green = (green > 255)?255:green; 
        
        colorR = red;
        colorG = green;
        colorB = blue;
        
        float[] hsbvals = new float[3];
        Color.RGBtoHSB(colorR, colorG, colorB, hsbvals);
        //Color color1 = new Color(Color.HSBtoRGB(hsbvals[0], hsbvals[1], (float)(1/Math.sqrt(dist))));
        Color color1 = new Color(Color.HSBtoRGB(hsbvals[0], hsbvals[1], hsbvals[2]));
        
        gg.setColor(color1);                        
        
        // nastaveni fontu
        Font font1 = new Font(currentFont, currentStyle, (int)(obj[5]*100/dist));          
        AffineTransform a = new AffineTransform();
        a.rotate(obj[2]);
        font1 = font1.deriveFont(a);
        
        gg.setFont(font1);
        
        // vykresleni
        // (  * 3 ? ~ ! .  : > @  # + ...9...
        str = mainFrame.jTextField1.getText();
        gg.drawString(str, (int)obj[0], (int)obj[1]);             
      
  		}

    }

    // osetreni udalosti vyvolane pohybem mysi
    public void this_mouseMoved(MouseEvent e) {
        this.mousePos = e.getPoint();
        this.mouseMove = true;
        this.repaint();
    }  
    
    // osetreni udalosti vyvolane kliknutim mysi - ulozeni obrazku do souboru
    public void this_mouseClicked(MouseEvent e) {
        this.repaint();   
    }  
}

// tridy pro obsluhu udalosti
class DrawFrame_this_mouseMotionAdapter extends MouseMotionAdapter {
    private DrawFrame adaptee;
    DrawFrame_this_mouseMotionAdapter(DrawFrame adaptee) {
        this.adaptee = adaptee;
    }

    public void mouseMoved(MouseEvent e) {
        //adaptee.this_mouseMoved(e);
    }

}

class DrawFrame_this_mouseAdapter extends MouseAdapter {
    private DrawFrame adaptee;
    DrawFrame_this_mouseAdapter(DrawFrame adaptee) {
        this.adaptee = adaptee;
    }

    public void mouseClicked(MouseEvent e) {
        adaptee.this_mouseClicked(e);
    }
}
