{#############################################################################}
{#                                                                           #}
{#  WinQUANT v2 - source code                                                #}
{#  Delphi version                                                           #}
{#  File: MainWin.pas v2.0                                                   #}
{#                                                                           #}
{#  (C) 2001 Petr Strnsk                                                   #}
{#  All rights reserved                                                      #}
{#                                                                           #}
{#  Web:     http://www.fi.muni.cz/~xstransk/winquant                        #}
{#  E-mail:  xstransk@fi.muni.cz                                             #}
{#           aargh@email.cz                                                  #}
{#                                                                           #}
{#############################################################################}
{#                                                                           #}
{#  This file is distributed as freeware and without warranties of any kind. #}
{#  You can use it in your own applications at your own risk.                #}
{#  See help file for more information.                                      #}
{#                                                                           #}
{#############################################################################}

unit MainWin;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ComCtrls, ExtCtrls, Document, Dialogs, Menus, ImgList, Gauges,
  ToolWin;

type
  TPagesDlg = class(TForm)
    DisplayBtn: TButton;
    ExitBtn: TButton;
    PreviewBtn: TButton;
    PreviewBox: TPaintBox;
    Bevel1: TBevel;
    ColorDialog: TColorDialog;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    FileNewItem: TMenuItem;
    FileOpenItem: TMenuItem;
    FileSaveItem: TMenuItem;
    FileSaveAsItem: TMenuItem;
    N1: TMenuItem;
    FileExitItem: TMenuItem;
    Help1: TMenuItem;
    HelpAboutItem: TMenuItem;
    ImageList1: TImageList;
    BookmarkCombo: TComboBox;
    WriteBtn: TButton;
    ReadBtn: TButton;
    SaveDialog: TSaveDialog;
    OpenDialog: TOpenDialog;
    PageControl: TPageControl;
    EquationTabSheet: TTabSheet;
    InputTypeRadio: TRadioGroup;
    DirectIRadioBtn: TRadioButton;
    CalcIRadioBtn: TRadioButton;
    FuncEdit: TEdit;
    DisplayTabSheet: TTabSheet;
    GroupBox2: TGroupBox;
    Label5: TLabel;
    Label8: TLabel;
    Label10: TLabel;
    ZoomRatioEdit: TEdit;
    PercentEdit: TEdit;
    GroupBox5: TGroupBox;
    Label6: TLabel;
    Label7: TLabel;
    Label9: TLabel;
    HorResEdit: TEdit;
    VerResEdit: TEdit;
    ResCombo: TComboBox;
    GroupBox6: TGroupBox;
    Label11: TLabel;
    Label12: TLabel;
    RangeFromEdit: TEdit;
    RangeToEdit: TEdit;
    ColorTabSheet: TTabSheet;
    Label13: TLabel;
    Bevel3: TBevel;
    GlobIntPrevBox: TPaintBox;
    IntervalTrack: TTrackBar;
    IntervalGroup: TGroupBox;
    GroupBox8: TGroupBox;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    IntFromEdit: TEdit;
    IntToEdit: TEdit;
    GroupBox10: TGroupBox;
    ColorPreviewBox: TPaintBox;
    Bevel2: TBevel;
    LColBitBtn: TBitBtn;
    RColBitBtn: TBitBtn;
    PatternPanel: TPanel;
    InvertPatternCheck: TCheckBox;
    PatternCombo: TComboBox;
    ParameterPanel: TPanel;
    Label17: TLabel;
    Label18: TLabel;
    LevellingEdit: TEdit;
    EffectCombo: TComboBox;
    IPCombo: TComboBox;
    NaNColBitBtn: TBitBtn;
    GroupBox9: TGroupBox;
    CopyIntBtn: TButton;
    PasteIntBtn: TButton;
    SwapColorsBtn: TButton;
    FnPanel: TPanel;
    FnTimesBtn: TButton;
    FnPlusBtn: TButton;
    FnMinusBtn: TButton;
    FnDivideBtn: TButton;
    FnExpBtn: TButton;
    FnLogBtn: TButton;
    FnLeftBtn: TButton;
    FnRightBtn: TButton;
    FnNullBtn: TButton;
    FnOneBtn: TButton;
    FnTwoBtn: TButton;
    FnThreeBtn: TButton;
    FnFourBtn: TButton;
    FnFiveBtn: TButton;
    FnSixBtn: TButton;
    FnSevenBtn: TButton;
    FnEightBtn: TButton;
    FnNineBtn: TButton;
    FnXBtn: TButton;
    FnYBtn: TButton;
    FnPiBtn: TButton;
    FnRndBtn: TButton;
    FnRndSgnBtn: TButton;
    FnRandGBtn: TButton;
    FnMaxBtn: TButton;
    FnHypotBtn: TButton;
    FnAbsBtn: TButton;
    FnATanBtn: TButton;
    FnCosBtn: TButton;
    FnEExpBtn: TButton;
    FnLnBtn: TButton;
    FnRoundBtn: TButton;
    FnSinBtn: TButton;
    FnSqrBtn: TButton;
    FnSqrtBtn: TButton;
    FnTruncBtn: TButton;
    FnAcosBtn: TButton;
    FnACoshBtn: TButton;
    FnASinBtn: TButton;
    FnASinhBtn: TButton;
    FnATanhBtn: TButton;
    FnCoshBtn: TButton;
    FnCotanBtn: TButton;
    FnSinhBtn: TButton;
    FnTanBtn: TButton;
    FnTanhBtn: TButton;
    FnFracBtn: TButton;
    FnSgnBtn: TButton;
    FnMinBtn: TButton;
    FnEBtn: TButton;
    FnPointBtn: TButton;
    FnClearBtn: TButton;
    FnDelBtn: TButton;
    GetRangeBtn: TButton;
    GetPreviewRangeBtn: TButton;
    RangeZoomInBtn: TBitBtn;
    RangeZoomOutBtn: TBitBtn;
    RangeLeftBtn: TBitBtn;
    RangeRightBtn: TBitBtn;
    AdaptBtn: TButton;
    GroupBox1: TGroupBox;
    GroupBox3: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    IntEdit1: TEdit;
    IntEdit2: TEdit;
    RevXBtn: TBitBtn;
    StretchXBtn: TBitBtn;
    ShrinkXBtn: TBitBtn;
    GroupBox4: TGroupBox;
    Label3: TLabel;
    Label4: TLabel;
    IntEdit3: TEdit;
    IntEdit4: TEdit;
    RevYBtn: TBitBtn;
    StretchYBtn: TBitBtn;
    ShrinkYBtn: TBitBtn;
    LeftBtn: TBitBtn;
    ZoomInBtn: TBitBtn;
    UpBtn: TBitBtn;
    CenterBtn: TBitBtn;
    RightBtn: TBitBtn;
    DownBtn: TBitBtn;
    ZoomOutBtn: TBitBtn;
    RestoreDefaultsBtn: TButton;
    EmptyPanel: TPanel;
    SplitBtn: TButton;
    RemoveBtn: TButton;
    SetEqLengthsbtn: TButton;
    UpdateBtn: TButton;
    BookmarkManager: TMenuItem;
    FnAngBtn: TButton;
    FnModBtn: TButton;
    WinQUANTHelp: TMenuItem;
    N2: TMenuItem;

  {* GENERAL EVENTS *}
    procedure ValueCheck(Sender: TObject);        {correct values set ?}
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure PreviewBoxPaint(Sender: TObject);   {paint PreviewBitmap}
    procedure PreviewBtnClick(Sender: TObject);   {calculate preview}
    procedure ExitClick(Sender: TObject);         {close}
    procedure DisplayBtnClick(Sender: TObject);   {display image}
    procedure WriteBtnClick(Sender: TObject);     {write bookmark}
    procedure ReadBtnClick(Sender: TObject);      {read bookmark}
  {* MENU *}
    procedure FileNewItemClick(Sender: TObject);        {new file}
    procedure FileSaveItemClick(Sender: TObject);       {save file}
    procedure FileSaveAsItemClick(Sender: TObject);     {save file as ...}
    procedure FileOpenItemClick(Sender: TObject);       {open file}
    procedure HelpAboutExecute(Sender: TObject);        {show about box}
    procedure BookmarkManagerClick(Sender: TObject);    {show bookmark manager}
  {* FUNCTION TABSHEET EVENTS *}
    procedure FuncEditExit(Sender: TObject);            {function string changed}
    procedure DirectIRadioBtnClick(Sender: TObject);    {direct function input set}
    procedure CalcIRadioBtnClick(Sender: TObject);      {calculator-like input set}
    procedure FnButtonsClick(Sender: TObject);          {'calculator' buttons clicked}
    procedure FnDelBtnClick(Sender: TObject);           {undo last 'calculator' button}
    procedure FnClearBtnClick(Sender: TObject);         {clear function}
  {* DISPLAY TABSHEET EVENTS *}
    procedure RevXBtnClick(Sender: TObject);      {reverse X-axis of interval}
    procedure RevYBtnClick(Sender: TObject);      {reverse Y-axis of interval}
    procedure ZoomIn(Sender: TObject);            {zoom in the interval}
    procedure ZoomOut(Sender: TObject);           {zoom out the interval}
    procedure UDBtnClick(Sender: TObject);        {move interval up or down}
    procedure LRBtnClick(Sender: TObject);        {move interval left or right}
    procedure CenterBtnClick(Sender: TObject);    {center interval}
    procedure ResComboChange(Sender: TObject);    {set predefined resolution}
    procedure GetRangeBtnClick(Sender: TObject);  {get value range from image or preview}
    procedure RangeZoomBtnClick(Sender: TObject); {zoom value rabge}
    procedure RangeLRBtnClick(Sender: TObject);   {move value range}
    procedure AdaptBtnClick(Sender: TObject);     {adapt display range}
    procedure RestoreDefaultsBtnClick(Sender: TObject);  {restore default settings}
  {* COLOR TABSHEET EVENTS *}
    procedure IntervalTrackChange(Sender: TObject);   {select active color interval}
    procedure ColorPreviewBoxPaint(Sender: TObject);  {paint color preview}
    procedure LColBitBtnClick(Sender: TObject);       {change left color}
    procedure RColBitBtnClick(Sender: TObject);       {change right color}
    procedure SplitBtnClick(Sender: TObject);         {split interval in two parts}
    procedure GlobIntPrevBoxPaint(Sender: TObject);   {show current coloring}
    procedure RemoveBtnClick(Sender: TObject);        {remove interval}
    procedure EffectComboChange(Sender: TObject);     {change chosen effect}
    procedure IntEditExit(Sender: TObject);           {change left and right interval range}
    procedure PatternChange(Sender: TObject);         {pattern changed}
    procedure InvertCheckClick(Sender: TObject);      {invert changed}
    procedure IPComboChange(Sender: TObject);         {interpolation changed}
    procedure LevellingEditExit(Sender: TObject);     {levelling width changed}
    procedure NaNColBitBtnClick(Sender: TObject);     {undefined value color changed}
    procedure SwapColorsBtnClick(Sender: TObject);    {swap colors}
    procedure CopyIntBtnClick(Sender: TObject);       {copy color interval}
    procedure PasteIntBtnClick(Sender: TObject);      {paste color interval}
    procedure SetEqLengthsbtnClick(Sender: TObject);  {equalize interval ranges}
    procedure WinQUANTHelpClick(Sender: TObject);     {execute help file}
  private
    procedure UpdateFormData;                     {write document data in form members}
    function CloseBookmarks: TModalResult;        {try to save unsaved bookmarks}
  end;

const PredefRes: array [0..5, 0..1] of integer =
          ((300,300),(320,200),(640,480),(800,600),(1024,768),(1280,1024));
      {predefined resolutions}

var PagesDlg: TPagesDlg;

implementation

uses UParser, Result, About, Calculations, Bookmark, BookmarkManager;

const ColBitBtnMargin = 5;

var Doc: TDocument;           {main document}
    Calculator: TCalculator;  {calculator object}
    PreviewBitmap: TBitmap;   {preview bitmap}
    Bookmarks: TBookmarks;    {bookmarks object}
    Tester: TSyntaxTester;    {function syntax tester}
    ZoomRatio: single;        {used by 'Zoom' functions}
    Percent: single;          {used by 'Move' function}
    CurrInt: integer;         {selected interval}
    CurrMark: integer;        {selected bookmark}
    CopyInt: TColorInterval;  {interval used by copy and paste}

{$R *.DFM}

 {* PRIVATE MEMBERS *}

function TPagesDlg.CloseBookmarks: TModalResult;
var DlgResult: word;
begin
  closebookmarks := mrOK;
  if Bookmarks.UnsavedChanges then begin
    DlgResult := MessageDlg('Save current unsaved bookmarks?', mtConfirmation, mbYesNoCancel, -1);
    if DlgResult = mrCancel then closebookmarks := mrCancel
    else if DlgResult = mrYes then FileSaveItemClick(Self);
  end;
end;

procedure TPagesDlg.UpdateFormData;
var loop: integer;
    ShownInt: TColorInterval;

  procedure DrawBitBtn(Color: TColor; Btn: TBitBtn; Text: string);
  begin                         {draw Right, Left and NaN Color buttons}
    with Btn.Glyph do begin
      Canvas.Brush.Color := Color;
      Canvas.Font.Color := Color xor $FFFFFF;
      Canvas.TextOut(0, 0, Text)
    end;
  end;

begin
  BookmarkCombo.Text := '';
  BookmarkCombo.Items.Clear;
  if Bookmarks.Count > 0 then begin
    BookmarkCombo.Style := csDropDown;
    for loop := 0 to Bookmarks.Count-1 do
      BookmarkCombo.Items.Add(Bookmarks.GetName(loop));
  end else BookmarkCombo.Style := csSimple;
  BookmarkCombo.ItemIndex := CurrMark;
  ResCombo.ItemIndex := 0;
  with Doc do begin
    FuncEdit.Text := Func;
    IntEdit1.Text := FloatToStr(XF);
    IntEdit2.Text := FloatToStr(XT);
    IntEdit3.Text := FloatToStr(YF);
    IntEdit4.Text := FloatToStr(YT);
    HorResEdit.Text := FloatToStr(GetXRes);
    VerResEdit.Text := FloatToStr(GetYRes);
    RangeFromEdit.Text := FloatToStr(RangeF);
    RangeToEdit.Text := FloatToStr(RangeT);
    ZoomRatioEdit.Text := FloatToStr(ZoomRatio);
    PercentEdit.Text := FloatToStr(Percent);

    ShownInt := GetInt(CurrInt)^;
    with IntervalTrack do begin
      Max := IntCount - 1;
      Enabled := Max <> 0
    end;
    IntervalGroup.Caption := 'Interval ' + IntToStr(CurrInt+1);
    IntFromEdit.Text := FloatToStr(ShownInt.FromPer*100);
    IntToEdit.Text := FloatToStr(ShownInt.ToPer*100);   {'0..100' <-> '0..1'}
    IntFromEdit.Enabled := CurrInt > 0;       {0% and 100% cannot be changed}
    IntToEdit.Enabled := CurrInt < IntCount-1;
    DrawBitBtn(ShownInt.LeftColor, LColBitBtn, ' Left Color ');
    DrawBitBtn(ShownInt.RightColor, RColBitBtn, 'Right Color');
    DrawBitBtn(UndefColor, NaNColBitBtn, ' NaN Color ');
    EffectCombo.ItemIndex := integer(ShownInt.Effect);
    PatternCombo.ItemIndex := ShownInt.Pattern;
    InvertPatternCheck.Checked := ShownInt.Invert;
    InvertPatternCheck.Checked := ShownInt.Invert;
    IPCombo.ItemIndex := integer(ShownInt.IPStyle);
    LevellingEdit.Text := FloatToStr(100 / ShownInt.LevORRand);

    PatternPanel.Visible := false;
    ParameterPanel.Visible := false;
    EmptyPanel.Visible := false;
    case ShownInt.Effect of                    {which settings panel on Color tabsheet will be visible}
      ceSolid, ceRandom: EmptyPanel.Visible := true;
      ceLevelling, ceLeft2Levelling, ceLevelling2Right, ceRandomFill:
        ParameterPanel.Visible := true;
      cePattern, cePatternInvert, ceLeft2Pattern,
        cePattern2Right: PatternPanel.Visible := true;
    end;
    ColorPreviewBox.Invalidate;
    GlobIntPrevBox.Invalidate;
  end;
end;

 {* PUBLIC MEMBERS *}

procedure TPagesDlg.ValueCheck(Sender: TObject);
begin
  with Doc do
    try
      XF := StrToFloat(IntEdit1.Text);
      XT := StrToFloat(IntEdit2.Text);
      YF := StrToFloat(IntEdit3.Text);
      YT := StrToFloat(IntEdit4.Text);
      SetRes(StrToInt(HorResEdit.Text), StrToInt(VerResEdit.Text));
      RangeF := StrToFloat(RangeFromEdit.Text);
      RangeT := StrToFloat(RangeToEdit.Text);
      if StrToFloat(ZoomRatioEdit.Text) <> 0 then
        ZoomRatio := StrToFloat(ZoomRatioEdit.Text);
      Percent := StrToFloat(PercentEdit.Text);
    except
      on EConvertError do UpdateFormData;
    end;

end;

procedure TPagesDlg.FormCreate(Sender: TObject);
begin
  BookmarkCombo.MaxLength := Document.MaxNameLength;
  FuncEdit.MaxLength := Document.MaxFunctionLength;
  DirectIRadioBtnClick(Sender);

  ZoomRatio := 2;
  Percent := 10;
  ResCombo.ItemIndex := 0;
  EffectCombo.ItemIndex := 0;
  PatternCombo.ItemIndex := 1;
  CurrInt := 0;
  CurrMark := -1;

  with LColBitBtn do begin
    Glyph.Width := (Width - 2 * ColBitBtnMargin);
    Glyph.Height := (Height - 2 * ColBitBtnMargin);
    Glyph.Canvas.Font.Style := [fsBold];
  end;
  with RColBitBtn do begin
    Glyph.Width := (Width - 2 * ColBitBtnMargin);
    Glyph.Height := (Height - 2 * ColBitBtnMargin);
    Glyph.Canvas.Font.Style := [fsBold];
  end;
  with NaNColBitBtn do begin
    Glyph.Width := (Width - 2 * ColBitBtnMargin);
    Glyph.Height := (Height - 2 * ColBitBtnMargin);
    Glyph.Canvas.Font.Style := [fsBold];
  end;

  PreviewBitmap := TBitmap.Create;
  PreviewBitmap.PixelFormat := pf32bit;
  Doc := TDocument.Create;
  Calculator := TCalculator.Create(PagesDlg);
  Bookmarks := TBookmarks.Create;
  Tester := TSyntaxTester.Create;

  CopyInt := Doc.GetInt(CurrInt)^;
  UpdateFormData;
end;

procedure TPagesDlg.FormDestroy(Sender: TObject);
begin
  Doc.Destroy;
  Calculator.Destroy;
  PreviewBitmap.Destroy;
  Bookmarks.Destroy;
  Tester.Destroy;
end;

procedure TPagesDlg.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if CloseBookmarks = mrCancel then Action := caNone
  else ResultWin.Abort;   {if calculation is in progress then abort it}
end;

procedure TPagesDlg.PreviewBoxPaint(Sender: TObject);
begin
  PreviewBox.Canvas.Draw (0,0,PreviewBitmap);
end;

procedure TPagesDlg.PreviewBtnClick(Sender: TObject);
var PreviewDoc: TDocument;
begin
  PreviewBtn.Enabled := false;
  PreviewDoc := TDocument.Create;
  with PreviewDoc do begin
    Copy(Doc);                                    {we must create new document and set resolution of a preview}
    SetRes(PreviewBox.Width, PreviewBox.Height);
    Calculator.Calculate(addr(PreviewBitmap), PreviewDoc);
    PreviewBox.Invalidate;
  end;
  PreviewBtn.Enabled := true;
end;

procedure TPagesDlg.ExitClick(Sender: TObject);
begin
  Close;
end;

procedure TPagesDlg.DisplayBtnClick(Sender: TObject);
begin
  DisplayBtn.Enabled := false;
  ResultWin.Execute(Doc);
  DisplayBtn.Enabled := true;
end;

procedure TPagesDlg.WriteBtnClick(Sender: TObject);
begin
  Doc.Name := BookmarkCombo.Text;
  Bookmarks.AddMark(Doc);
  CurrMark := Bookmarks.FindName(Doc.Name);
  UpdateFormData;
end;

procedure TPagesDlg.ReadBtnClick(Sender: TObject);
var Index: integer;
begin
  Index := Bookmarks.FindName(BookmarkCombo.Text);
  if Index <> -1 then begin
    Doc.Copy(Bookmarks.GetMark(Index));
    CurrInt := 0;
    CurrMark := Index;
    UpdateFormData;
  end;
end;

procedure TPagesDlg.FileNewItemClick(Sender: TObject);
begin
  if CloseBookmarks <> mrCancel then begin
    Bookmarks.Clear;
    CurrMark := -1;
    UpdateFormData;
  end;
end;

procedure TPagesDlg.FileSaveItemClick(Sender: TObject);
begin
  if Bookmarks.FileName = '' then FileSaveAsItemClick(Sender)
  else Bookmarks.SaveToFile;
end;

procedure TPagesDlg.FileSaveAsItemClick(Sender: TObject);
begin
  if Bookmarks.FileName <> '' then SaveDialog.FileName := Bookmarks.FileName;
  with SaveDialog do
    if Execute then begin
      Bookmarks.FileName := FileName;
      Bookmarks.SaveToFile;
    end;
end;

procedure TPagesDlg.FileOpenItemClick(Sender: TObject);
begin
  if CloseBookmarks <> mrCancel then begin
    if Bookmarks.FileName <> '' then OpenDialog.FileName := Bookmarks.FileName;
    with OpenDialog do
      if Execute then begin
        Bookmarks.FileName := FileName;
        Bookmarks.LoadFromFile;
      end;
    CurrMark := 0;
    UpdateFormData;
  end;
end;

procedure TPagesDlg.HelpAboutExecute(Sender: TObject);
begin
  AboutBox.ShowModal;
end;

procedure TPagesDlg.BookmarkManagerClick(Sender: TObject);
begin
  with BookmarkManagerDlg do
    if BookmarkManagerDlg.Execute(Bookmarks)= mrOK then
      Bookmarks.Copy(GetBookmarks);
  UpdateFormData;
end;

procedure TPagesDlg.FuncEditExit(Sender: TObject);
begin
  Doc.Func := FuncEdit.Text;
end;

procedure TPagesDlg.RevXBtnClick(Sender: TObject);
var pom: single;
begin
  with Doc do begin
    pom := XF;
    XF := XT;
    XT := pom;
  end;
  UpdateFormData;
end;

procedure TPagesDlg.RevYBtnClick(Sender: TObject);
var pom: single;
begin
  with Doc do begin
    pom := YF;
    YF := YT;
    YT := pom;
  end;
  UpdateFormData;
end;

procedure TPagesDlg.ZoomIn(Sender: TObject);
begin
  if (Sender = ZoomInBtn) or (Sender = StretchXBtn) then
    with Doc do begin
      XF := XF / ZoomRatio;
      XT := XT / ZoomRatio;
    end;
  if (Sender = ZoomInBtn) or (Sender = StretchYBtn) then
    with Doc do begin
      YF := YF / ZoomRatio;
      YT := YT / ZoomRatio;
    end;
  UpdateFormData;
end;

procedure TPagesDlg.ZoomOut(Sender: TObject);
begin
  if (Sender = ZoomOutBtn) or (Sender = ShrinkXBtn) then
    with Doc do begin
      XF := XF * ZoomRatio;
      XT := XT * ZoomRatio;
    end;
  if (Sender = ZoomOutBtn) or (Sender = ShrinkYBtn) then
    with Doc do begin
      YF := YF * ZoomRatio;
      YT := YT * ZoomRatio;
    end;
  UpdateFormData;
end;

procedure TPagesDlg.UDBtnClick(Sender: TObject);
var Len: single;
begin
  with Doc do begin
    Len := (YT - YF) * Percent / 100;
    if Sender = UpBtn then Len := -Len;
    YF := YF - Len;
    YT := YT - Len
  end;
  UpdateFormData;
end;

procedure TPagesDlg.LRBtnClick(Sender: TObject);
var Len: single;
begin
  with Doc do begin
    Len := (XT - XF) * Percent / 100;
    if Sender = RightBtn then Len := -Len;
    XF := XF + Len;
    XT := XT + Len
  end;
  UpdateFormData;
end;

procedure TPagesDlg.CenterBtnClick(Sender: TObject);
var Rad: single;
begin
  with Doc do begin
    Rad := (XT - XF) / 2;
    XF := -Rad;
    XT := Rad;
    Rad := (YT - YF) / 2;
    YF := -Rad;
    YT := Rad;
  end;
  UpdateFormData;
end;

procedure TPagesDlg.ResComboChange(Sender: TObject);
begin
  with ResCombo do Doc.SetRes(PredefRes[ItemIndex,0], PredefRes[ItemIndex,1]);
  UpdateFormData;
end;

procedure TPagesDlg.GetRangeBtnClick(Sender: TObject);
begin
  if Sender = GetRangeBtn then ResultWin.GetLastMinMax(Doc.RangeF, Doc.RangeT)
  else if Sender = GetPreviewRangeBtn then begin
    Doc.RangeF := Calculator.MinVal;
    Doc.RangeT := Calculator.MaxVal;
  end;
  UpdateFormData;
end;

procedure TPagesDlg.RangeZoomBtnClick(Sender: TObject);
var TmpZoomRatio: single;
begin
  if Sender = RangeZoomInBtn then TmpZoomRatio := 1 / ZoomRatio
  else TmpZoomRatio := ZoomRatio;
  with Doc do begin
    RangeF := RangeF * TmpZoomRatio;
    RangeT := RangeT * TmpZoomRatio;
  end;
  UpdateFormData;
end;

procedure TPagesDlg.RangeLRBtnClick(Sender: TObject);
var Len: single;
begin
  with Doc do begin
    Len := (RangeT - RangeF) * Percent / 100;
    if Sender = RangeLeftBtn then Len := -Len;
    RangeF := RangeF + Len;
    RangeT := RangeT + Len
  end;
  UpdateFormData;
end;

procedure TPagesDlg.AdaptBtnClick(Sender: TObject);
var Mid, Dia: single;
begin
  with Doc do begin
    Mid := (YT + YF) / 2;
    Dia := (GetYRes * (XT - XF)) / (2 * GetXRes);
    YF := Mid - Dia;
    YT := Mid + Dia;
  end;
  UpdateFormData;
end;

procedure TPagesDlg.RestoreDefaultsBtnClick(Sender: TObject);
begin
  ZoomRatio := 2;
  Percent := 10;
  UpdateFormData;
end;

procedure TPagesDlg.IntervalTrackChange(Sender: TObject);
begin
  If IntervalTrack.Position <> CurrInt then begin
    CurrInt := IntervalTrack.Position;
    UpdateFormData;
  end;
end;

procedure TPagesDlg.ColorPreviewBoxPaint(Sender: TObject);
var loop, loop2: integer;
begin
  with ColorPreviewBox do
    for loop := 0 to Width do
      for loop2 := 0 to Height do
        Canvas.Pixels[loop, loop2] :=
          Doc.GetColorAtInt(loop/Width, Doc.GetInt(CurrInt)^, Point(loop,loop2));
end;

procedure TPagesDlg.LColBitBtnClick(Sender: TObject);
begin
  with ColorDialog do begin
    Color := Doc.GetInt(CurrInt)^.LeftColor;
    if Execute then begin
      Doc.GetInt(CurrInt)^.LeftColor := Color;
      UpdateFormData;
    end;
  end;
end;

procedure TPagesDlg.RColBitBtnClick(Sender: TObject);
begin
  with ColorDialog do begin
    Color := Doc.GetInt(CurrInt)^.RightColor;
    if Execute then begin
      Doc.GetInt(CurrInt)^.RightColor := Color;
      UpdateFormData;
    end;
  end;
end;

procedure TPagesDlg.NaNColBitBtnClick(Sender: TObject);
begin
  with ColorDialog do begin
    Color := Doc.UndefColor;
    if Execute then begin
      Doc.UndefColor := Color;
      UpdateFormData;
    end;
  end;
end;

procedure TPagesDlg.SplitBtnClick(Sender: TObject);
begin
  Doc.SplitInt(CurrInt);
  UpdateFormData;
end;

procedure TPagesDlg.GlobIntPrevBoxPaint(Sender: TObject);
var loop, loop2: integer;
    ShownInt: TColorInterval;

  function RoundUp(X: single): integer;
  begin
    Result := Trunc(x);
    if X <> Result then Inc(Result);
  end;

begin
  with GlobIntPrevBox do begin
    for loop := 0 to Width do
      for loop2 := 3 to Height do
        Canvas.Pixels[loop, loop2] := Doc.GetColorGlobal(loop/Width, Point(loop,loop2));
    ShownInt := Doc.GetInt(CurrInt)^;
    Canvas.Brush.Color := clBlack;
    Canvas.FillRect(Rect(0, 0, Width, 3));
    Canvas.Pen.Color := clWhite;
    Canvas.MoveTo(RoundUp(ShownInt.FromPer*Width),2);
    Canvas.LineTo(RoundUp(ShownInt.FromPer*Width),0);
    Canvas.LineTo(RoundUp(ShownInt.ToPer*Width)-1,0);
    Canvas.LineTo(RoundUp(ShownInt.ToPer*Width)-1,3);
  end;
end;

procedure TPagesDlg.RemoveBtnClick(Sender: TObject);
begin
  Doc.DelAndResizeInt(CurrInt);
  CurrInt := 0;
  UpdateFormData;
end;

procedure TPagesDlg.EffectComboChange(Sender: TObject);
begin
  Doc.GetInt(CurrInt)^.Effect := TColorEffect(EffectCombo.ItemIndex);
  UpdateFormData;
end;

procedure TPagesDlg.IntEditExit(Sender: TObject);
begin
  try
    if Sender = IntFromEdit
      then Doc.ChangeFromInt(CurrInt, StrToFloat(IntFromEdit.Text)/100)
      else Doc.ChangeToInt(CurrInt, StrToFloat(IntToEdit.Text)/100);
  except
    on EConvertError do {nothing};
  end;
  UpdateFormData;
end;

procedure TPagesDlg.SetEqLengthsbtnClick(Sender: TObject);
begin
  Doc.EqualizeIntLengths;
  UpdateFormData;
end;

procedure TPagesDlg.PatternChange(Sender: TObject);
begin
  Doc.GetInt(CurrInt)^.Pattern := PatternCombo.ItemIndex;
  UpdateFormData;
end;

procedure TPagesDlg.InvertCheckClick(Sender: TObject);
begin
  Doc.GetInt(CurrInt)^.Invert := InvertPatternCheck.Checked;
  UpdateFormData;
end;

procedure TPagesDlg.IPComboChange(Sender: TObject);
begin
  Doc.GetInt(CurrInt)^.IPStyle := TIPStyle(IPCombo.ItemIndex);
  UpdateFormData;
end;

procedure TPagesDlg.LevellingEditExit(Sender: TObject);
var Num: single;
begin
  try
    num := StrToFloat(LevellingEdit.Text);
    if (num > 0) and (num < 100) then
      Doc.GetInt(CurrInt)^.LevORRand := 100 / num;
  except
    on EConvertError do {nothing};
  end;
  UpdateFormData;
end;

procedure TPagesDlg.SwapColorsBtnClick(Sender: TObject);
var Tmp: TColor;
begin
  with Doc.GetInt(CurrInt)^ do begin
    Tmp := LeftColor;
    LeftColor := RightColor;
    RightColor := Tmp;
  end;
  UpdateFormData;
end;

procedure TPagesDlg.CopyIntBtnClick(Sender: TObject);
begin
  CopyInt := Doc.GetInt(CurrInt)^;
end;

procedure TPagesDlg.PasteIntBtnClick(Sender: TObject);
begin
  Doc.CopyIntColoring(CurrInt, CopyInt);
  UpdateFormData;
end;


procedure TPagesDlg.DirectIRadioBtnClick(Sender: TObject);
var loop: integer;
begin
  FuncEdit.Enabled := true;
  with FnPanel do
    for loop := 0 to ControlCount - 1 do
      Controls[loop].Enabled := false;
end;

procedure TPagesDlg.CalcIRadioBtnClick(Sender: TObject);
var loop: integer;
begin
  FuncEdit.Text := '';
  FuncEdit.Enabled := false;
  with FnPanel do
    for loop := 0 to ControlCount - 1 do
      Controls[loop].Enabled := true;
  Tester.Reset;
end;

procedure TPagesDlg.FnButtonsClick(Sender: TObject);
var Button: TButton;
begin
   Button := Sender as TButton;
   Tester.AddTag(TFnButtonTags(Button.Tag), Button.Caption);
   Doc.Func := Tester.GetString;
   FuncEdit.Text := Doc.Func;
end;

procedure TPagesDlg.FnDelBtnClick(Sender: TObject);
begin
  Tester.DeleteTag;
  Doc.Func := Tester.GetString;
  FuncEdit.Text := Doc.Func;
end;

procedure TPagesDlg.FnClearBtnClick(Sender: TObject);
begin
  FuncEdit.Text := '';
  Tester.Reset;
end;

procedure TPagesDlg.WinQUANTHelpClick(Sender: TObject);
begin
  Application.HelpCommand(HELP_FINDER, 0);
end;

end.
